

  const chessboard = document.getElementById("chessboard");
  const startButton = document.getElementById("start-button");
  const flipButton = document.getElementById("flip-button");

  const canvas = document.getElementById("chessboard");
  const canvas2 = document.getElementById("canvas2");
  const ctx = canvas.getContext("2d");
  const ctx2 = canvas2.getContext('2d');

  const squareSize = canvas.width / 8;
  const pieceSize = 0.95 * squareSize;

  const moves = [];

  var mvNr = 1;
  var whMove = [];
  var blMove = [];

  var sourceCol, sourceRow; // Common variables to store the source column and row


  let isWhiteTurn = true;
  let isBoardFlipped = false; // Variable to indicate if the board is flipped

  let selectedPiece = null;
  let selectedPieceIndex = -1;

  const indicatorRadius = 12;
  const indicatorPadding = 10;

  const whiteSquareColor = "#f0d9b5";
  const blackSquareColor = "#b58863";


// Add a variable to store the selected computer level
let computerLevel = "beginner";

// Function to get the selected computer level
function getComputerLevel() {
  const levelRadios = document.getElementsByName("computer-level");
  for (const radio of levelRadios) {
    if (radio.checked) {
      computerLevel = radio.value;
      break;
    }
  }
}


  const pieceImg = {
    "wK": "./images/white-king.svg",
    "bK": "./images/black-king.svg",
    "wQ": "./images/white-queen.svg",
    "bQ": "./images/black-queen.svg",
    "wR": "./images/white-rook.svg",
    "bR": "./images/black-rook.svg",
    "wB": "./images/white-bishop.svg",
    "bB": "./images/black-bishop.svg",
    "wN": "./images/white-knight.svg",
    "bN": "./images/black-knight.svg",
    "wp": "./images/white-pawn.svg",
    "bp": "./images/black-pawn.svg"
    // Add other piece images here
  };

const whitePieces = [
  { name: "wR", value: 5, x: 0, y: 7, ind: 0, active: true, hasMoved: false },
  { name: "wN", value: 3, x: 1, y: 7, ind: 1, active: true, hasMoved: false },
  { name: "wB", value: 3, x: 2, y: 7, ind: 2, active: true, hasMoved: false },
  { name: "wQ", value: 9, x: 3, y: 7, ind: 3, active: true, hasMoved: false },
  { name: "wK", value: 100, x: 4, y: 7, ind: 4, active: true, hasMoved: false },
  { name: "wB", value: 3, x: 5, y: 7, ind: 5, active: true, hasMoved: false },
  { name: "wN", value: 3, x: 6, y: 7, ind: 6, active: true, hasMoved: false },
  { name: "wR", value: 5, x: 7, y: 7, ind: 7, active: true, hasMoved: false },
  { name: "wp", value: 1, x: 0, y: 6, ind: 8, active: true, hasMoved: false },
  { name: "wp", value: 1, x: 1, y: 6, ind: 9, active: true, hasMoved: false },
  { name: "wp", value: 1, x: 2, y: 6, ind: 10, active: true, hasMoved: false },
  { name: "wp", value: 1, x: 3, y: 6, ind: 11, active: true, hasMoved: false },
  { name: "wp", value: 1, x: 4, y: 6, ind: 12, active: true, hasMoved: false },
  { name: "wp", value: 1, x: 5, y: 6, ind: 13, active: true, hasMoved: false },
  { name: "wp", value: 1, x: 6, y: 6, ind: 14, active: true, hasMoved: false },
  { name: "wp", value: 1, x: 7, y: 6, ind: 15, active: true, hasMoved: false }
];


const blackPieces = [
  { name: "bR", value: 5, x: 0, y: 0, ind: 1, active: true, hasMoved: false },
  { name: "bN", value: 3, x: 1, y: 0, ind: 2, active: true, hasMoved: false },
  { name: "bB", value: 3, x: 2, y: 0, ind: 3, active: true, hasMoved: false },
  { name: "bQ", value: 9, x: 3, y: 0, ind: 4, active: true, hasMoved: false },
  { name: "bK", value: 100, x: 4, y: 0, ind: 4, active: true, hasMoved: false },
  { name: "bB", value: 3, x: 5, y: 0, ind: 5, active: true, hasMoved: false },
  { name: "bN", value: 3, x: 6, y: 0, ind: 6, active: true, hasMoved: false },
  { name: "bR", value: 5, x: 7, y: 0, ind: 7, active: true, hasMoved: false },
  { name: "bp", value: 1, x: 0, y: 1, ind: 8, active: true, hasMoved: false },
  { name: "bp", value: 1, x: 1, y: 1, ind: 9, active: true, hasMoved: false },
  { name: "bp", value: 1, x: 2, y: 1, ind: 10, active: true, hasMoved: false },
  { name: "bp", value: 1, x: 3, y: 1, ind: 11, active: true, hasMoved: false },
  { name: "bp", value: 1, x: 4, y: 1, ind: 12, active: true, hasMoved: false },
  { name: "bp", value: 1, x: 5, y: 1, ind: 13, active: true, hasMoved: false },
  { name: "bp", value: 1, x: 6, y: 1, ind: 14, active: true, hasMoved: false },
  { name: "bp", value: 1, x: 7, y: 1, ind: 15, active: true, hasMoved: false }
];


// xxxxxx   Board for computer calculation start here

let board;
board = setupBoard();

// Declare the history array in the global scope
let history = [];

// Initialize currentPlayer to represent the starting player ("white" or "black")
let currentPlayer = "white";

// Function to switch the currentPlayer after each move
function switchPlayer() {
  currentPlayer = currentPlayer === "white" ? "black" : "white";
}


function setupBoard() {
  // Create an 8x8 array to represent the chessboard
  const board = new Array(64).fill(null);

  // Set up the white pieces (starting from the bottom rank)
  board[56] = { type: "rook", color: "white" };
  board[57] = { type: "knight", color: "white" };
  board[58] = { type: "bishop", color: "white" };
  board[59] = { type: "queen", color: "white" };
  board[60] = { type: "king", color: "white" };
  board[61] = { type: "bishop", color: "white" };
  board[62] = { type: "knight", color: "white" };
  board[63] = { type: "rook", color: "white" };

  // Set up the white pawns (seventh rank)
  for (let i = 48; i < 56; i++) {
    board[i] = { type: "pawn", color: "white" };
  }

  // Set up the black pieces (starting from the top rank)
  board[0] = { type: "rook", color: "black" };
  board[1] = { type: "knight", color: "black" };
  board[2] = { type: "bishop", color: "black" };
  board[3] = { type: "queen", color: "black" };
  board[4] = { type: "king", color: "black" };
  board[5] = { type: "bishop", color: "black" };
  board[6] = { type: "knight", color: "black" };
  board[7] = { type: "rook", color: "black" };

  // Set up the black pawns (second rank)
  for (let i = 8; i < 16; i++) {
    board[i] = { type: "pawn", color: "black" };
  }

  return board;
}

// xxxxxx   Board for computer calculation end here


// Function to draw the chessboard
function drawBoard() {
  // Draw the chessboard squares
  for (let row = 0; row < 8; row++) {
    for (let col = 0; col < 8; col++) {
      const x = col * squareSize;
      const y = row * squareSize;

      ctx.fillStyle = (row + col) % 2 === 0 ? whiteSquareColor : blackSquareColor;
      ctx.fillRect(x, y, squareSize, squareSize);
    }
  }


  // Draw turn indicator
  const indicatorX = canvas.width - indicatorPadding - indicatorRadius;
  const indicatorY = canvas.height / 2;

  // Draw indicator background
  ctx.fillStyle = isWhiteTurn ? "#FFF" : "#000";
  ctx.beginPath();
  ctx.arc(indicatorX, indicatorY, indicatorRadius, 0, Math.PI * 2);
  ctx.closePath();
  ctx.fill();

  // Draw indicator text
  ctx.fillStyle = isWhiteTurn ? "#000" : "#FFF";
  ctx.font = "16px Arial";
  ctx.textAlign = "center";
  ctx.textBaseline = "middle";
  ctx.fillText(isWhiteTurn ? "White" : "Black", indicatorX, indicatorY);


  // Draw row numbers
  ctx.fillStyle = "#000";
  ctx.font = "18px Arial";
  for (let row = 0; row < 8; row++) {
    const x = 5;
    const y = (row + 0.9) * squareSize;
    ctx.fillText((isBoardFlipped ? row + 1 : 8 - row).toString(), x, y);
    // ctx.fillText((8 - row).toString(), x, y);
  }

  // Draw column letters
  ctx.fillStyle = "#000";
  ctx.font = "16px Arial";
  // const letters = ["A", "B", "C", "D", "E", "F", "G", "H"];
  const letters = isBoardFlipped ? ["H", "G", "F", "E", "D", "C", "B", "A"] : ["A", "B", "C", "D", "E", "F", "G", "H"];
  
  for (let col = 0; col < 8; col++) {
    const x = (col + 0.9) * squareSize;
    const y = 10;
    ctx.fillText(letters[col], x, y);
  }
}


function drawPiece(piece, x, y) {
  const img = new Image();
  img.src = pieceImg[piece.name];
  img.onload = function() {
    let size = pieceSize;
    if (piece.name === 'bp') {
      size = 1 * pieceSize; // Adjust size for black pawns
    }
    const offsetX = (squareSize - size) / 2;
    const offsetY = (squareSize - size) / 2;
    ctx.drawImage(img, x * squareSize + offsetX, y * squareSize + offsetY, size, size);
  };
}


function drawPieces() {
  ctx.clearRect(0, 0, canvas.width, canvas.height);
  console.log("Clear: - - - - - - - - - - - - - -");

  drawBoard(); // Draw the board first

  for (let i = 0; i < whitePieces.length; i++) {
    const piece = whitePieces[i];
    if (piece.active) {
      const col = isBoardFlipped ? 7 - piece.x : piece.x;
      const row = isBoardFlipped ? 7 - piece.y : piece.y;
      drawPiece(piece, col, row);
      // drawPiece(piece, piece.x, piece.y);
	  // console.log("Name:", piece.name, "x:", piece.x, "y:", piece.y);
    }
  }

  for (let i = 0; i < blackPieces.length; i++) {
    const piece = blackPieces[i];
    if (piece.active) {
      const col = isBoardFlipped ? 7 - piece.x : piece.x;
      const row = isBoardFlipped ? 7 - piece.y : piece.y;
      drawPiece(piece, col, row);
      // drawPiece(piece, piece.x, piece.y);
	  // console.log("Name:", piece.name, "x:", piece.x, "y:", piece.y);
    }
  }
}


function initializeBoard() {
  getComputerLevel();
  drawPieces();
}

// Add event listener for the flip button
flipButton.addEventListener("click", () => {
  isBoardFlipped = !isBoardFlipped;
  drawPieces();
});



  // Automatically trigger the start button click event on page load
  initializeBoard();




