


function printMoves() {
  ctx2.clearRect(0, 0, canvas2.width, canvas2.height);
  ctx2.font = "16px Arial";
  ctx2.fillStyle = "black";

  const moveCount = blMove.length;
  const startMoveIndex = Math.max(moveCount - 12, 0); // Only print the last 12 moves
  const columnLetters = ['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h'];

  for (let i = startMoveIndex; i < moveCount; i++) {
    const moveNumber = i + 1;
    const blackMove = blMove[i];
    const whiteMove = whMove[i];

    const whitePieceCode = whiteMove.piece === "wp" ? "" : whiteMove.piece.charAt(1); // Set to empty string if piece code is "p"
    const blackPieceCode = blackMove.piece === "bp" ? "" : blackMove.piece.charAt(1);

    const whiteMoveText = `${whitePieceCode}${columnLetters[whiteMove.from.col]}${8 - whiteMove.from.row}-${columnLetters[whiteMove.to.col]}${8 - whiteMove.to.row}`;
    const blackMoveText = `${blackPieceCode}${columnLetters[blackMove.from.col]}${8 - blackMove.from.row}-${columnLetters[blackMove.to.col]}${8 - blackMove.to.row}`;

    const xPos = 20;
    const yPos = 20 + (i - startMoveIndex) * 20;

    ctx2.fillText(moveNumber.toString() + ".", xPos, yPos);
    ctx2.fillText(whiteMoveText, xPos + 25, yPos);
    ctx2.fillText(blackMoveText, xPos + 110, yPos);

  }

  if (!isWhiteTurn) {
	const lastWhiteMove = whMove[whMove.length - 1];
    const moveNumber = moveCount + 1;
    const whitePieceCode = lastWhiteMove.piece === "wp" ? "" : lastWhiteMove.piece.charAt(1);

    // const moveText = `${moveNumber}. ${lastWhiteMove.from.col},${lastWhiteMove.from.row} to ${lastWhiteMove.to.col},${lastWhiteMove.to.row}`;
    const moveText = `${whitePieceCode}${columnLetters[lastWhiteMove.from.col]}${8 - lastWhiteMove.from.row}-${columnLetters[lastWhiteMove.to.col]}${8 - lastWhiteMove.to.row}`;
 
    const xPos = 20;
    const yPos = 20 + Math.max(moveCount - startMoveIndex, 0) * 20;

    ctx2.fillText(moveNumber.toString() + ".", xPos, yPos);
    ctx2.fillText(moveText, xPos + 25, yPos);
  }
}

